var pako = require('pako')

function convertBase64ToBlob(b64Data, contentType) {
    contentType = contentType || '';
    const sliceSize = 512;
    b64Data = b64Data.replace(/^[^,]+,/, '');
    b64Data = b64Data.replace(/\s/g, '');
    const byteCharacters = window.atob(b64Data);
    const byteArrays = [];
    for (let offset = 0; offset < byteCharacters.length; offset += sliceSize) {
         const slice = byteCharacters.slice(offset, offset + sliceSize);
         const byteNumbers = new Array(slice.length);
         for (let i = 0; i < slice.length; i++) {
             byteNumbers[i] = slice.charCodeAt(i);
         }
         const byteArray = new Uint8Array(byteNumbers);
         byteArrays.push(byteArray);
    }
   return new Blob(byteArrays, {type: contentType});
  }
 
  function decompressArrayBuffer(base64) {
    return pako.inflate(base64ToArrayBuffer(base64));
  }

  function compressArrayBuffer(ab) {
    return arrayBufferToBase64(pako.deflate(ab));
  }

  function decompressBase64(base64) {
    return arrayBufferToBase64(decompressArrayBuffer(base64));
  }

  function base64ToArrayBuffer(base64) {
    let binary_string =  window.atob(base64);
    let len = binary_string.length;
    let bytes = new Uint8Array(len);
    for (let i = 0; i < len; i++)        {
        bytes[i] = binary_string.charCodeAt(i);
    }
    return bytes.buffer;
}

function arrayBufferToBase64(buffer) {
  var binary = '';
  var bytes = new Uint8Array( buffer );
  var len = bytes.byteLength;
  for (var i = 0; i < len; i++) {
      binary += String.fromCharCode( bytes[ i ] );
  }
  return window.btoa(binary);
}
 
 module.exports = {
    convertBase64ToBlob, 
    decompressArrayBuffer,
    compressArrayBuffer, 
    decompressBase64,
    base64ToArrayBuffer, 
    arrayBufferToBase64
 };